#include <stdlib.h>

#include "../libs/gba.h"
#include "../libs/gbalib.h"
#include "../libs/m4_gbalib.h"
#include "../sworld3.h"

#include "../images/skull.h"
#include "../images/title_pcx.h"
#include "../images/instructions.h"

#define sprite_off  ((Sprite) {512,0,170,0})
#define sprite_clean ((Sprite) {0,0,0,0})

extern player_t player;

void score_to_string (u8 * str)
{
  str [0] = ((player.score / 10000) % 10) + '0';
  str [1] = ((player.score /1000) %10) + '0';
  str [2] = ((player.score /100) %10) + '0';
  str [3] = ((player.score /10) %10) + '0';
  str [4] = (player.score %10) + '0';
  str [5] = 0;
}

void draw_skull_screen (void)
{
  u8 *str = "shenmansell@hotmail.com";

  m4_load_pcx (skull);
  m4_string_center (149,str);
  set_bkg_pal ((u8 *)&skull[skull_LEN-768]);

  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE | BG2_ENABLE;
  REG_DISPSTAT = 0;
  m4_setframe(1);

  wait_for_button ();
}


const char title_str [9][35] = {
  "Ride the lightning",
  "And (infinite) justice for all",
  "Send in the clones",
  "S World fights back",
  "Because we can",
  "This time it's personal",
  "First Blood - part 3",
  "Breakfast of Champions",
  "Chubby Rain"
};

const char last_score [12] = "Last Score:";
void draw_title_screen (void)
{
  u8 score [10];
  u16 x = rand();
  x = x % 9;

  m4_load_pcx (title_pcx);
  m4_string (10,45, (char *) title_str[x]);
  m4_string (10,60, (char *) last_score);
  score_to_string (score);
  m4_string (70,60, score);

  set_bkg_pal ((u8 *)&title_pcx[title_pcx_LEN-768]);

  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE | BG2_ENABLE;
  REG_DISPSTAT = 0;
  m4_setframe(0);

  wait_for_button ();

}

void show_title (void)
{
  u8 x;
  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE;
  REG_DISPSTAT = 0;

  for (x = 0; x< 128; x++)
  {
    OAM[x] = sprite_off;
  }

  m4_setframe(1);
  draw_title_screen ();

}

void show_skull (void)
{
  u8 x;
  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE;
  REG_DISPSTAT = 0;

  for (x = 0; x< 128; x++)
  {
    OAM[x] = sprite_off;
  }

  m4_setframe(0);
  draw_skull_screen ();
}

void show_instructions (void)
{
  u8 x;
  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE;
  REG_DISPSTAT = 0;

  for (x = 0; x< 128; x++)
  {
    OAM[x] = sprite_off;
  }

  m4_setframe(0);

  m4_load_pcx (instructions_pcx);
  set_bkg_pal ((u8 *)&instructions_pcx[instructions_pcx_LEN-768]);

  REG_DISPCNT = 0 | BG_MODE_4 | OBJ_1D_MAP | OBJ_ENABLE | BG2_ENABLE;
  REG_DISPSTAT = 0;
  m4_setframe(1);

  wait_for_button ();
}

