#ifndef sworld
  
  #define sworld 3
  #include "libs/gba.h"
  
  #define no_type 0
  #define player_type 1
  #define player_shot_type 2
  #define enemy_type 3
  #define enemy_shot_type 4
  #define shot_power_type 5
  #define speed_power_type 6

typedef struct player_t 
{
  u16 x;
  u16 y;
  u16 score;
  u16 dead; 
  u16 invincible;
  s16 lives;
  Sprite sprite;
  void (*fire) (void);
  u16 fire_param1;
  u16 fire_param2;
  u8 power;
  u8 last_fire;
  
} player_t;

  #define max_player_shots            50

typedef struct player_shot_t 
{
  s16 x;
  s16 y;
  s16 dx;
  s16 dy;
  s16 power;
  Sprite sprite;
} player_shot_t;

  #define max_enemies 20

typedef struct enemy_t 
{
  s16 x;
  s16 y;
  s16 dx;
  s16 dy;
  u16 last_fire;
  u16 hit_points;
  u16 size_x;
  u16 size_y;
  u16 score;
  u8 (*turn) (u8 enemy_num);
  Sprite sprite;
  u8 dead;
} enemy_t;

  #define max_enemy_shots 20
typedef struct enemy_shot_t 
{
  s16 x;
  s16 y;
  s16 dx;
  s16 dy;
  s16 power;
  Sprite sprite;
} enemy_shot_t;

  #define max_misc_actors 20

typedef struct misc_actor_t 
{
  s16 x;
  s16 y;
  s16 dx;
  s16 dy;
  u16 count;
  u16 type;
  Sprite sprite;
} misc_actor_t;

  #define misc_explosion 1
  #define misc_sparkle 2
  #define misc_coin 3

  #define enemy_shots_sprite_start 8
  #define player_shots_sprite_start  28
  #define misc_actors_sprite_start 78
  #define player_sprite 98
  #define enemy_sprite_start 101

#endif
